config/routes.rb
Rails.application.routes.draw do
  root to: 'admin/admin#index'

  namespace :admin do
    get '/' => 'admin#index'
    resources :campaigns
    resources :candidates
    resources :offices
  end
end

app/models/application_record.rb
class ApplicationRecord < ActiveRecord::Base
  self.abstract_class = true
end

app/models/campaign.rb
class Campaign < ApplicationRecord
  belongs_to :office
  belongs_to :candidate

  validates :office_id, presence: true
  validates :candidate_id, presence: true
  validates :year, presence: true

  # TODO: This should move to a decorator
  def title
    "#{self.office.name} #{self.year.stamp("1999")} — #{self.candidate.fullname}"
  end
end

app/models/candidate.rb
class Candidate < ApplicationRecord
  mount_uploader :avatar, AvatarUploader

  has_many :campaigns
  has_many :offices, through: :campaigns

  validates :firstname,
            presence: true
  validates :lastname,
            presence: true

  def fullname
    "#{firstname} #{lastname} #{suffix}"
  end

end

app/models/city.rb
class City < ApplicationRecord
  include GlobalID::Identification

  has_many :office, as: :locatable

  belongs_to :county, inverse_of: :cities
  has_many :zipcodes, inverse_of: :cities

  validates :county, presence: true
  validates :name,   presence: true, uniqueness: {case_sensitive: false, scope: :county_id}
end

app/models/county.rb
class County < ApplicationRecord
  include GlobalID::Identification

  has_many :office, as: :locatable

  belongs_to :state, inverse_of: :counties
  has_many   :cities, inverse_of: :county, dependent: :destroy

  validates :state, presence: true
  validates :name,  presence: true, uniqueness: {case_sensitive: false, scope: :state_id}
end

app/models/office.rb
class Office < ApplicationRecord
  has_many :campaigns
  has_many :candidates, through: :campaigns
  belongs_to :locatable, polymorphic: true

  validates :name, presence: true
  validates :locatable_id, presence: true
  validates :locatable_type, presence: true
end

app/models/state.rb
class State < ApplicationRecord
  include GlobalID::Identification

  has_many :office, as: :locatable
  has_many :counties, inverse_of: :state, dependent: :destroy

  validates :name,           presence: true, uniqueness: {case_sensitive: false}
  validates :two_digit_code, presence: true, uniqueness: {case_sensitivie: false}
end

app/models/zipcode.rb
class Zipcode < ApplicationRecord
  belongs_to :city, inverse_of: :zipcodes

  validates :city, presence: true
  validates :code, presence: true, uniqueness: {case_sensitive: false}
end

app/controllers/admin/admin_controller.rb
class Admin::AdminController < ApplicationController
  http_basic_authenticate_with :name => "lpadmin", :password => "QoAbe49){G32"

  layout 'admin'

  def index
  end
end

app/controllers/admin/campaigns_controller.rb
class Admin::CampaignsController < Admin::AdminController
  before_action :set_campaign, only: [:show, :edit, :update, :destory]

  respond_to :html, :json

  def index
    @campaigns = Campaign.order(:year)
    respond_with @campaigns
  end

  def show
    respond_with @campaign
  end

  def new
    @campaign = Campaign.new
    respond_with @campaign
  end

  def create
    @campaign = Campaign.new(resource_params)

    respond_to do |format|
      if @campaign.save
        format.html { redirect_to [:admin, :campaigns], notice: 'Campaign was successfully created' }
        format.json { render json: @campaign, status: :created, location: @campaign }
      else
        format.html { render action: "new" }
        format.json { render json: @campaign.errors, status: :unprocessable_entity }
      end
    end
  end

  def edit
  end

  def update
    respond_to do |format|
      if @campaign.update(resource_params)
        format.html { redirect_to [:admin, :campaigns], notice: 'Campaign was successfully updated' }
        format.json { render json: @campaign, status: :updated, location: @campaign }
      else
        format.html { render action: "edit" }
        format.json { render json: @campaign.errors, status: :unprocessable_entity }
      end
    end
  end

  def destroy
    @campaign.destroy

    respond_to do |format|
      format.html { redirect_to :back }
      format.json { head :no_content }
    end
  end

  private

  def set_campaign
    @campaign = Campaign.find(params[:id])
  end

  def resource_name
    :campaign
  end

  def permitted_resource_params
    [:office_id, :year, :url, :candidate_statement, :candidate_id, :instagram, :facebook]
  end

end

app/controllers/admin/candidates_controller.rb
class Admin::CandidatesController < Admin::AdminController
  before_action :set_candidate, only: [:show, :edit, :update, :destory]

  respond_to :html, :json

  def index
    @candidates = Candidate.order(:lastname)
    respond_with @candidates
  end

  def show
    respond_with @candidate
  end

  def new
    @candidate = Candidate.new
    respond_with @candidate
  end

  def create
    @candidate = Candidate.new(resource_params)

    respond_to do |format|
      if @candidate.save
        format.html { redirect_to [:admin, :candidates], notice: 'Candidate was successfully created' }
        format.json { render json: @candidate, status: :created, location: @candidate }
      else
        format.html { render action: "new" }
        format.json { render json: @candidate.errors, status: :unprocessable_entity }
      end
    end
  end

  def edit
  end

  def update
    respond_to do |format|
      if @candidate.update(resource_params)
        format.html { redirect_to [:admin, :candidates], notice: 'Candidate was successfully updated' }
        format.json { render json: @candidate, status: :updated, location: @candidate }
      else
        format.html { render action: "edit" }
        format.json { render json: @candidate.errors, status: :unprocessable_entity }
      end
    end
  end

  def destroy
    @candidate.destroy

    respond_to do |format|
      format.html { redirect_to :back }
      format.json { head :no_content }
    end
  end

  private

  def set_candidate
    @candidate = Candidate.find(params[:id])
  end

  def resource_name
    :candidate
  end

  def permitted_resource_params
    [:firstname, :lastname, :suffix, {avatars: []}]
  end

end

app/controllers/admin/offices_controller.rb
class Admin::OfficesController < Admin::AdminController
  before_action :set_office, only: [:show, :edit, :update, :destory]

  respond_to :html, :json

  def index
    @offices = Office.order(:name)
    respond_with @offices
  end

  def show
    respond_with @office
  end

  def new
    @office = Office.new
    respond_with @office
  end

  def create
    @office = Office.new(resource_params)

    respond_to do |format|
      if @office.save
        format.html { redirect_to [:admin, :offices], notice: 'Office was successfully created' }
        format.json { render json: @office, status: :created, location: @office }
      else
        format.html { render action: "new" }
        format.json { render json: @office.errors, status: :unprocessable_entity }
      end
    end
  end

  def edit
  end

  def update
    respond_to do |format|
      if @office.update(resource_params)
        format.html { redirect_to [:admin, :offices], notice: 'Office was successfully updated' }
        format.json { render json: @office, status: :updated, location: @office }
      else
        format.html { render action: "edit" }
        format.json { render json: @office.errors, status: :unprocessable_entity }
      end
    end
  end

  def destroy
    @office.destroy

    respond_to do |format|
      format.html { redirect_to :back }
      format.json { head :no_content }
    end
  end

  private

  def set_office
    @office = Office.find(params[:id])
  end

  def resource_name
    :office
  end

  def permitted_resource_params
    [:name, :description, :locatable_type, :locatable_id, :locatable_global_id]
  end

end

app/controllers/application_controller.rb
require "application_responder"

class ApplicationController < ActionController::Base
  self.responder = ApplicationResponder
  respond_to :html

  protect_from_forgery with: :exception

  def resource_params
    params.require(resource_name).permit(*permitted_resource_params)
  end

end

app/helpers/admin/admin_helper.rb
module Admin::AdminHelper
end

app/helpers/admin/campaigns_helper.rb
module Admin::CampaignsHelper
end

app/helpers/admin/candidates_helper.rb
module Admin::CandidatesHelper
end

app/helpers/admin/offices_helper.rb
module Admin::OfficesHelper
end

app/helpers/application_helper.rb
module ApplicationHelper
end

app/views/admin/campaigns/_form.html.erb
<%= simple_form_for [:admin, @campaign] do |f| %>
  <%= f.input :year,
              as: :date,
              discard_day: true,
              discard_month: true,
              start_year: 2017,
              label: 'Year of election',
              prompt: 'Choose Year' %>

  <%= f.association :office,
                    prompt: 'Choose the office',
                    collection: Office.order('name ASC') %>

  <%= f.association :candidate,
                    prompt: 'Choose the Candidate',
                    label_method: lambda { |can| "#{can.fullname}"},
                    collection: Candidate.order('lastname ASC') %>

  <%= f.input :url,
             label: 'Campaign Website',
             input_html: { minlength: 1 } %>
  <%= f.input :instagram,
             label: 'Campaign Instagram',
             input_html: { minlength: 1 } %>
  <%= f.input :facebook,
             label: 'Campaign Facebook',
             input_html: { minlength: 1 } %>
  <% f.input :twitter,
             label: 'Campaign Twitter',
             input_html: { minlength: 1 } %>
  <%= f.input :candidate_statement,
  as: :text %>
  <%= f.submit %>
<% end %>

app/views/admin/campaigns/edit.html.erb
<h1>Edit Campaign</h1>
<%= render 'form' %>

app/views/admin/campaigns/index.html.erb
<p class="functions">
  <%= link_to "New Campaign", new_admin_campaign_path %>
</p>
<h1>Campaign</h1>

<table>
  <thead>
    <tr>
      <th>Campaign</th>
      <th>Actions</th>
    </tr>
  </thead>
  <tbody>
  <% @campaigns.each do |campaign| %>
    <tr>
      <td>
        <%= link_to campaign.title, admin_campaign_path(campaign) %>
      </td>
      <td>
        <%= link_to "Edit", edit_admin_campaign_path(campaign) %>
      </td>
    </tr>
  <% end -%>
  </tbody>
</table>

app/views/admin/campaigns/new.html.erb
<h1>Add New Campaign</h1>
<%= render 'form' %>

app/views/admin/campaigns/show.html.erb
<p class="breadcrumbs">
  <%= link_to "Campaigns »", admin_campaigns_path %>
</p>

<h1><%= @campaign.title %></h1>
<p><%= link_to "Edit", edit_admin_campaign_path(@campaign) %></p>

<p>Website: <%= @campaign.url %></p>
<p>Twitter: <%= @campaign.twitter %></p>
<p>Facebook: <%= @campaign.facebook %></p>
<p>Instagram: <%= @campaign.instagram %></p>

app/views/admin/candidates/_form.html.erb
<%= simple_form_for [:admin, @candidate], html: { multipart: true } do |f| %>
  <%= f.input :firstname,
              input_html: { minlength: 1 } %>
  <%= f.input :lastname,
              input_html: { minlength: 1 } %>
  <%= f.input :suffix,
              input_html: { minlength: 1, maxlength: 5 } %>
  <%= image_tag(@candidate.avatar_url(:thumb)) if @candidate.avatar? %>
  <%= f.input :avatar,
              as: :file,
              label: 'Candidate Photo' %>

  <%= f.input :instagram,
              input_html: { minlength: 1 } %>
  <%= f.input :twitter,
              input_html: { minlength: 1 } %>
  <%= f.input :linkedin,
              input_html: { minlength: 1 } %>
  <%= f.input :facebook,
              input_html: { minlength: 1 } %>
  <%= f.submit %>
<% end %>

app/views/admin/candidates/edit.html.erb
<h1>Edit Candidate: <%= @candidate.fullname %></h1>
<%= render 'form' %>

app/views/admin/candidates/index.html.erb
<p class="functions">
  <%= link_to "New Candidate", new_admin_candidate_path %>
</p>
<h1>Candidates</h1>

<table>
  <thead>
    <tr>
      <th>Candidate</th>
      <th>Actions</th>
    </tr>
  </thead>
  <tbody>
  <% @candidates.each do |candidate| %>
    <tr>
      <td>
        <%= link_to candidate.fullname, admin_candidate_path(candidate) %>
      </td>
      <td>
        <%= link_to "Edit", edit_admin_candidate_path(candidate) %>
      </td>
    </tr>
  <% end -%>
  </tbody>
</table>

app/views/admin/candidates/new.html.erb
<h1>Add New Candidate</h1>
<%= render 'form' %>

app/views/admin/candidates/show.html.erb
<p class="breadcrumbs">
  <%= link_to "Candidates »", admin_candidates_path %>
</p>
<h1><%= @candidate.fullname %></h1>
<%= image_tag(@candidate.avatar_url(:small)) if @candidate.avatar? %>
<p><%= link_to "Edit", edit_admin_candidate_path(@candidate) %></p>

app/views/admin/offices/_form.html.erb
<%= form_for [:admin, @office] do |f| %>
<ol>
  <li>
    <%= f.label :locatable_global_id, 'Jurisdiction' %>
    <%= f.polymorphic_select :locatable_global_id, [State, County, City] %>
  </li>
  <li>
    <%= f.label :name %>
    <%= f.text_field :name %>
  </li>
  <li>
    <%= f.label :description %>
    <%= f.text_area :description %>
  </li>
  <li>
    <%= f.submit %>
  </li>
</ol>
<% end %>

app/views/admin/offices/edit.html.erb
<h1>Admin::Offices#edit</h1>
<p>Find me in app/views/admin/offices/edit.html.erb</p>

app/views/admin/offices/index.html.erb
<p class="functions">
  <%= link_to "New Office", new_admin_office_path %>
</p>
<h1>Offices</h1>

<table>
  <thead>
    <tr>
      <th>Office</th>
      <th>Jurisdiction</th>
      <th>Actions</th>
    </tr>
  </thead>
  <tbody>
  <% @offices.each do |office| %>
    <tr>
      <td>
        <%= link_to office.name, admin_office_path(office) %>
      </td>
      <td>
        <%= office.locatable.name %>
      </td>
      <td>
        <%= link_to "Edit", edit_admin_office_path(office) %>
      </td>
    </tr>
  <% end -%>
  </tbody>
</table>

app/views/admin/offices/new.html.erb
<h1>New Office</h1>
<%= render 'form' %>

app/views/admin/offices/show.html.erb
<h1>Admin::Offices#show</h1>
<p>Find me in app/views/admin/offices/show.html.erb</p>

app/views/layouts/admin.html.erb
<!DOCTYPE html>
<html>
  <head>
    <title>CandidateDb</title>
    <%= csrf_meta_tags %>

    <%= stylesheet_link_tag    'admin', media: 'all', 'data-turbolinks-track': 'reload' %>
    <%= javascript_include_tag 'application', 'data-turbolinks-track': 'reload' %>
  </head>

  <body>
    <header id="masthead">
      <h1>LP Candidate Admin</h1>
      <nav id="main">
        <%= render_navigation(context: :admin) %>
      </nav>
    </header>
    <main>
      <%= yield %>
    </main>
    <footer id="page_footer">
      <p>©2017 Libertarian National Committee</p>
    </footer>
  </body>
</html>

app/views/layouts/application.html.erb
<!DOCTYPE html>
<html>
  <head>
    <title>CandidateDb</title>
    <%= csrf_meta_tags %>

    <%= stylesheet_link_tag    'application', media: 'all', 'data-turbolinks-track': 'reload' %>
    <%= javascript_include_tag 'application', 'data-turbolinks-track': 'reload' %>
  </head>

  <body>
    <%= yield %>
  </body>
</html>